var currentTabPane;
var settingsUI = function () {
    var items = [
        [{
            el: {
                type: 'llabel',
                levelStyle: 1,
                value: FR.i18nText("Plugin-Memory_Alarm_Operation_For_High_Memory")
            }
        }],
        [
            {el: createMemoryUI()}
        ],
        [
            {el: {type: 'llabel', levelStyle: 1, value: FR.i18nText('Plugin-Memory_Alarm_Title_Big_Temp')}}
        ],
        [
            {el: createTempUI()}
        ],
        [
            {
                el: {
                    type: 'tablelayout',
                    rowSize: [25],
                    columnSize: [70, 16, 'fill'],
                    vgap: 2,
                    items: [
                        [
                            {
                                el: {type: 'llabel', levelStyle: 1, value: FR.i18nText('Plugin-Memory_Alarm_Life_Cycle')}
                            },
                            {
                                el: getDetailElement(FR.i18nText('Plugin-Memory_Alarm_Live_Time_Exp'))
                            },
                            {
                                el:$('<div class="first_level_style"/>')
                            }

                        ]
                    ]
                }
            }
        ],
        [
            {el: createLifeUI()}
        ],
        [
            {
                el: {
                    type: 'tablelayout',
                    rowSize: [25],
                    columnSize: [40, 16, 'fill'],
                    vgap: 2,
                    items: [
                        [
                            {
                                el: {type: 'llabel', levelStyle: 1, value: FR.i18nText('Plugin-Memory_Alarm_Setting')}
                            },
                            {
                                el: getDetailElement(FR.i18nText('Plugin-Memory_Alarm_Mode_Exp'))
                            },
                            {
                                el:$('<div class="first_level_style"/>')
                            }

                        ]
                    ]
                }
            }
        ],
        [
            {el: createModeUI()}
        ]
    ];
    var rowSize = [21, 100, 21, 70, 25, 135, 25, 21];
    var height = 620;
    var basicTablelayout = {
        widgetName: 'memory_alarm',
        type: 'tablelayout',
        items: items,
        columnSize: [750],
        rowSize: rowSize,
        vgap: 20
    };
    return {
        title: FR.i18nText('Plugin-Memory_Alarm'),
        content: {
            widgetName: 'memory_alarm_content',
            type: 'confirm',
            firstBtnMargin: 0,
            text4OK: FR.i18nText("FS-Frame-Simple_Save"),
            text4Cancel: null,
            width: 650,
            height: height,
            btnsAlignment: 'left',
            closeAfterAction: false,
            doSize: true,
            onOK: function () {
                saveMemory();
            },
            contentWidget: basicTablelayout
        }
    };
};
var createModeUI = function () {
    return {
        widgetName: 'modePane',
        type: 'tablelayout',
        rowSize: [21],
        columnSize: [150, 200],
        vgap: 15,
        items: [
            [
                {el: {type: 'llabel', value: FR.i18nText('Plugin-Memory_Alarm_Mode')}},
                {
                    el: {
                        type: 'combo', widgetName: 'mode', allowBlank: false, directEdit: false,
                        items: [
                            {text: FR.i18nText('Plugin-Memory_Alarm_Mode_Production'), value: 1},
                            {text: FR.i18nText('Plugin-Memory_Alarm_Mode_Debug'), value: 0}
                        ],
                        value: 1
                    }
                }
            ]
        ]
    };
};
var createLifeUI = function () {
    return {
        widgetName: 'lifePane',
        type: 'tablelayout',
        rowSize: [21, 21, 21, 21],
        columnSize: [150, 150],
        vgap: 15,
        items: [
            [{el: {type: 'llabel', value: FR.i18nText('Plugin-Memory_Alarm_Live_Time')}},
                {
                    el: createTimeUI(FR.i18nText('Plugin-Memory_Alarm_Unit_Min'), {
                        widgetName: 'lifeCycle',
                        value: 60,
                        minValue: -1,
                        allowNegative: true
                    })
                }
            ],
            [
                {el: {type: 'llabel', value: FR.i18nText('Plugin-Memory_Alarm_Time_Check')}},
                {
                    el: createTimeUI(FR.i18nText('Plugin-Memory_Alarm_Unit_MS'), {
                        widgetName: 'checkTime',
                        value: 400000,
                        minValue: 30000,
                        allowBlank: false
                    })
                }
            ],
            [

                {el: {type: 'llabel', value: FR.i18nText('Plugin-Memory_Alarm_Time_Dead')}},
                {
                    el: createTimeUI(FR.i18nText('Plugin-Memory_Alarm_Unit_MS'), {
                        widgetName: 'deadTime',
                        type: 'number',
                        value: 400000,
                        minValue: 30000,
                        allowBlank: false
                    })
                }
            ],
            [
                {el: {type: 'llabel', value: FR.i18nText('Plugin-Memory_Alarm_Heartbeat')}},
                {el: {type: 'switch', widgetName: 'heartbeat'}}
            ]

        ]
    };
};
var getDetailElement = function (text) {
    return $('<div class="memory-alarm-detail-up first_level_style"/>').hover(
        function () {
            $(this).addClass('memory-alarm-detail-hover');
        },
        function () {
            $(this).removeClass('memory-alarm-detail-hover')
        }
    ).click(
        function () {
            var $tipPre = $('<pre/>').append($('<span/>').text(text));
            var $tipContext = $('<div class="memory-alarm-detailmsg"/>')
                .append($tipPre);
            $tipContext.appendTo($('body')).css({
                position: 'absolute',
                left: $(this).offset().left + $(this).width(),
                top: $(this).offset().top + $(this).height(),
                'z-index': FR.widget.opts.zIndex++
            });
            $(document).bind('mousedown.tip', function (e) {
                var target = e.target;
                if (!$(target).isChildAndSelfOf('.memory-alarm-detailmsg')) {
                    $tipContext.remove();
                    $(document).unbind('mousedown.tip');
                }
            });
        }
    );
};

var createTimeUI = function (unit, config) {
    var timeConfig = $.extend({
        type: 'number',
        minValue: 1
    }, config);
    return {
        type: 'tablepane',
        rowSize: [21],
        colSize: [60, 10, 30],
        items: [
            [
                timeConfig,
                {},
                {
                    type: 'llabel',
                    value: unit
                }
            ]
        ]
    };
};
var createTempUI = function () {
    return {
        widgetName: 'tempPane',
        type: 'tablelayout',
        rowSize: [21, 21],
        columnSize: [150, 450],
        vgap: 15,
        items: [
            [
                {
                    el: {
                        widgetName: 'openRowControl',
                        type: 'checkbox', text: FR.i18nText('Plugin-Memory_Alarm_DS_Max_Count'), selected: false,
                        listeners: [{
                            eventName: 'afteredit',
                            action: function () {
                                var isOpen = this.getValue();
                                currentTabPane.getWidgetByName("maxDSRowCount").setEnable(isOpen);
                            }
                        }]
                    }
                },
                {
                    el: {type: 'number', widgetName: 'maxDSRowCount', minValue: 255, allowNegative: false}
                }
            ],
            [
                {el: {type: 'llabel', value: FR.i18nText('Plugin-Memory_Alarm_Row_Msg')}},

                {
                    el: {
                        type: 'text', widgetName: 'rowOverMsg',
                        'watermark': FR.i18nText('Performance-Monitor_Row_Over_Warning_Info')
                    }
                }
            ]
        ]
    };
};
var createMemoryUI = function () {
    return {
        widgetName: 'memoryPane',
        type: 'tablelayout',
        rowSize: [21, 21, 21],
        columnSize: [150, 450],
        vgap: 15,
        items: [
            [
                {el: {type: 'llabel', value: FR.i18nText('Plugin-Memory_Alarm_Queue_Wait')}},
                {
                    el: {
                        type: 'tablepane',
                        colSize: [70, 60, 85, 60, 70],
                        rowSize: [20],
                        items: [
                            [{
                                type: 'llabel',
                                value: FR.i18nText("Plugin-Memory_Alarm_Msg_Head")
                            }, {
                                type: 'number', widgetName: 'queuePercent', minValue: 0, maxValue: 100
                            }, {
                                type: 'llabel',
                                value: FR.i18nText("Plugin-Memory_Alarm_Msg_Body_Clear")
                            }, {
                                type: 'number', widgetName: 'lifeKeepTime', minValue: 0
                            }, {
                                type: 'llabel',
                                value: FR.i18nText("Plugin-Memory_Alarm_Msg_Foot1")
                            }]
                        ]
                    }
                }
            ],
            [
                {el: {type: 'llabel', value: FR.i18nText('Plugin-Memory_Memory_Release')}},
                {
                    el: {
                        type: 'tablepane',
                        colSize: [70, 60, 150],
                        rowSize: [20],
                        items: [
                            [{
                                type: 'llabel',
                                value: FR.i18nText("Plugin-Memory_Alarm_Msg_Head")
                            }, {
                                type: 'number', widgetName: 'interruptPercent', minValue: 0, maxValue: 100
                            }, {
                                type: 'llabel',
                                value: FR.i18nText("Plugin-Memory_Alarm_Msg_Body_Clear_All_Session")
                            }]
                        ]
                    }
                }
            ],
            [
                {el: {type: 'llabel', value: FR.i18nText('Plugin-Memory_Alarm_Message')}},
                {
                    el: {
                        type: 'tablepane',
                        colSize: [450],
                        rowSize: [20],
                        items: [
                            [{
                                type: 'text', widgetName: 'message', 'watermark':FR.i18nText('Performance-Monitor_Memory_Warning_Info')
                            }]
                        ]
                    }
                }
            ]
        ]
    };
};
var saveMemory = function () {
    var ip = currentTabPane.getWidgetByName('interruptPercent').getValue();
    var message = currentTabPane.getWidgetByName('message').getValue();
    var rowOverMsg = currentTabPane.getWidgetByName('rowOverMsg').getValue();
    var mode = currentTabPane.getWidgetByName('mode').getValue();
    var lifeCycle = currentTabPane.getWidgetByName('lifeCycle').getValue();
    var queueMemoryPercent = currentTabPane.getWidgetByName('queuePercent').getValue();
    var lifeKeepTime = currentTabPane.getWidgetByName('lifeKeepTime').getValue();
    var maxDSRowCount = currentTabPane.getWidgetByName('maxDSRowCount').getValue();
    var checkTime = currentTabPane.getWidgetByName('checkTime').getValue();
    var deadTime = currentTabPane.getWidgetByName('deadTime').getValue();
    var heartbeat = currentTabPane.getWidgetByName('heartbeat').getValue();
    var openRowControl = currentTabPane.getWidgetByName('openRowControl').getValue();
    if ($(".fr-invalid").length > 0) {
        FR.Msg.toast(FR.i18nText('Plugin-Memory_Alarm_Update_Failure'));
        return;
    }
    FR.ajax({
        url: FR.servletURL + '?op=memory_alarm&cmd=update',
        data: {
            'interruptPercent': ip,
            'message': message,
            'rowOverMsg': rowOverMsg,
            'mode': mode,
            'lifeCycle': lifeCycle,
            'queueMemoryPercent': queueMemoryPercent,
            'lifeKeepTime': lifeKeepTime,
            'checkTime': checkTime,
            'deadTime': deadTime,
            'heartbeat': heartbeat,
            'openRowControl': openRowControl,
            'maxDSRowCount': maxDSRowCount
        },
        complete: function (res, status) {
            if (status === 'success') {
                var info = FR.jsonDecode(res.responseText);
                if (info.status === 'success') {
                    FR.Msg.toast(FR.i18nText('Plugin-Memory_Alarm_Update_Success'));
                } else {
                    FR.Msg.toast(FR.i18nText('Plugin-Memory_Alarm_Update_Failure'));
                }
            }
        }
    });
};
FS.Plugin.SystemItems.push({

    ui: settingsUI,

    pop: function (idx, tabPane) {
        currentTabPane = tabPane;
        FR.ajax({
            url: FR.servletURL + '?op=memory_alarm&cmd=populate&_=' + new Date().getTime(),
            complete: function (res, status) {
                var r = FR.jsonDecode(res.responseText);
                tabPane.getWidgetByName("interruptPercent").setValue(r.interruptPercent);
                tabPane.getWidgetByName("message").setValue(r.message);
                tabPane.getWidgetByName("rowOverMsg").setValue(r.rowOverMsg);
                tabPane.getWidgetByName("mode").setValue(r.mode);
                tabPane.getWidgetByName("lifeCycle").setValue(r.lifeCycle);
                tabPane.getWidgetByName("queuePercent").setValue(r.queueMemoryPercent);
                tabPane.getWidgetByName("lifeKeepTime").setValue(r.lifeKeepTime);
                tabPane.getWidgetByName("maxDSRowCount").setValue(r.maxDSRowCount);
                tabPane.getWidgetByName("checkTime").setValue(r.checkTime);
                tabPane.getWidgetByName("deadTime").setValue(r.deadTime);
                tabPane.getWidgetByName("heartbeat").setValue(r.heartbeat);
                tabPane.getWidgetByName("openRowControl").setValue(r.openRowControl);
                tabPane.getWidgetByName("maxDSRowCount").setEnable(r.openRowControl);
            }
        });
    }
});